Subject: Re: [PATCH vhost v11 05/10] virtio_ring: introduce virtqueue_dma_dev()

From: Jakub Kicinski <[email-masked]>
Date: Mon, 31 Jul 2023 19:36:06 -0700

On Tue, 1 Aug 2023 10:03:44 +0800 Xuan Zhuo wrote:
> > Virtio is either a SW
> > construct or offloaded to very capable HW, so either way cost of
> > creating an extra instance for DPDK or whatever else is very low.  
> 
> The extra instance is virtio-net?
> 
> I think there is a gap. So let me give you a brief introduction of our case.
> 
> Firstly, we donot use dpdk. We use the AF_XDP, because of that the AF_XDP is
> more simpler and easy to deploy for the nginx.
> 
> We use the AF_XDP to speedup the UDP of the quic. By the library, the APP just
> needs some simple change.
> 
> On the AliYun, the net driver is virtio-net. So we want the virtio-net support
> the AF_XDP.
> 
> I guess what you mean is that we can speed up through the cooperation of devices
> and drivers, but our machines are public clouds, and we cannot change the
> back-end devices of virtio under normal circumstances.
> 
> Here I do not know the different of the real hw and the virtio-net.

You have this working and benchmarked or this is just and idea?

What about io_uring zero copy w/ pre-registered buffers.
You'll get csum offload, GSO, all the normal perf features.